/************************************************************************************/
/*  Program name CAPFNDIMP_DOC_SEQ.sql                                              */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDIMP_DOC_SEQ';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_DOCUMENT_SEQ;

	lv_Next_Seq_ID	NUMBER;

BEGIN

	--  RENAME
	UPDATE
		FND_DOCUMENT_SEQUENCES
	SET
		Name	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(Name,1,4),Name)
	WHERE	Doc_Sequence_ID	IN	(
								SELECT
									Doc_Sequence_ID
								FROM
									CRST_FND_DOCUMENT_SEQ
								);

	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	FND_DOCUMENT_SEQUENCES_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_FND_DOCUMENT_SEQ_MAP VALUES
			(
			C1.DOC_SEQUENCE_ID,
			CAPBRIMP_MAPPING.RenameStr(SUBSTR(C1.Name,1,4),C1.Name),
			lv_Next_Seq_ID,
			C1.NAME
			);

			INSERT INTO FND_DOCUMENT_SEQUENCES
			VALUES
			(
			lv_Next_Seq_ID,												--DOC_SEQUENCE_ID,
			C1.NAME,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),			--LAST_UPDATED_BY,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),				--CREATED_BY,
			C1.LAST_UPDATE_LOGIN,
			C1.APPLICATION_ID,
			C1.AUDIT_TABLE_NAME,
			C1.MESSAGE_FLAG,
			C1.START_DATE,
			C1.TYPE,
			C1.DB_SEQUENCE_NAME,
			C1.END_DATE,
			C1.INITIAL_VALUE,
			C1.TABLE_NAME,
			C1.ATTRIBUTE_CATEGORY,
			C1.ATTRIBUTE1,
			C1.ATTRIBUTE2,
			C1.ATTRIBUTE3,
			C1.ATTRIBUTE4,
			C1.ATTRIBUTE5,
			C1.ATTRIBUTE6,
			C1.ATTRIBUTE7,
			C1.ATTRIBUTE8,
			C1.ATTRIBUTE9,
			C1.ATTRIBUTE10,
			C1.ATTRIBUTE11,
			C1.ATTRIBUTE12,
			C1.ATTRIBUTE13,
			C1.ATTRIBUTE14,
			C1.ATTRIBUTE15
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
